//+------------------------------------------------------------------+
//|                                                     MovingLR.mq4 |
//|                                                           Candid |
//|                                                 candid.110mb.com |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "candid.110mb.com"
 
#property indicator_chart_window
#property indicator_color1 Blue
 
extern int Frame = 20;             //  
extern int Shift = 0;              //  
extern int Sample = 0;          //  

string OName = "MovingLR";   

int PreBars;
datetime BarTime;

int bFrame;            //  
int eFrame;            //  
int bSample;           //  
int eSample;           //  
int MinBars;           // 

bool FirstFrame;       //

int pos,pos0;          // 
double X[];            // 
double XX[];           // 
double Y[];            // 
double YY[];           // 
double XY[];           // 
int FPtr;              // 
double Norma;          // 
double SumX;           //
double SumY;           //
double SumXX;          //
double SumXY;          //
double SumYY;          //
double A;              //
double B;              //

double Buf[];

int init() {

   if (Frame < 3) {
     Alert("MovingLR:  Frame    2");
     return(0);
   }  
   PreBars = 0;
   BarTime = 0;
   MinBars = Shift+Frame+1;
   ArrayResize(X,Frame);
   ArrayResize(XX,Frame);
   ArrayResize(Y,Frame);
   ArrayResize(YY,Frame);
   ArrayResize(XY,Frame);

   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(0,Buf);

   ObjectCreate(OName,OBJ_TREND,0,0,0,0);
   ObjectCreate(OName+"_V",OBJ_VLINE,0,0,0,0);
   ObjectCreate(OName+"_V1",OBJ_VLINE,0,0,0,0);

  return(0);
}

int deinit() {
  ObjectDelete(OName);
  ObjectDelete(OName+"_V");
  ObjectDelete(OName+"_V1");
  return(0);
}
 
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  FirstFrame = true;
  eSample = Shift+Frame;
  bSample = eSample+Sample-1;
  if (bSample > Bars-1 || Sample == 0) bSample = Bars-1;
  return(bSample);
}

int start() {  
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Alert("MovingLR:    ");
    return(0);
  }  
  if (Bars-PreBars == 1 && BarTime==Time[1]) bSample = Frame+Shift;
  else bSample = Reset();
  PreBars = Bars;  
  BarTime=Time[0];
  for(bFrame = bSample; bFrame >= eSample; bFrame--) {
    eFrame = bFrame-Frame+1;
    if (FirstFrame) {
      FirstFrame = false;
      SumX=0.0;
      SumY=0.0;
      SumXX=0.0;
      SumXY=0.0;
      SumYY=0.0;
      for (pos = bFrame; pos >= eFrame; pos--) {
        FPtr = bFrame-pos;
        X[FPtr] = Bars-pos;
        XX[FPtr] = X[FPtr]*X[FPtr];
        Y[FPtr] = 0.5*(High[pos]+Low[pos]);
        YY[FPtr] = Y[FPtr]*Y[FPtr];
        XY[FPtr] = X[FPtr]*Y[FPtr];
        SumX = SumX + X[FPtr];
        SumXX = SumXX + XX[FPtr];
        SumY = SumY + Y[FPtr];
        SumYY = SumYY + YY[FPtr];
        SumXY = SumXY + XY[FPtr];
      }
    } else {  //  if (FirstFrame)
      FPtr++;
      if (FPtr >= Frame) FPtr = 0;
      SumX = SumX - X[FPtr];
      SumXX = SumXX - XX[FPtr];
      SumY = SumY - Y[FPtr];
      SumYY = SumYY - YY[FPtr];
      SumXY = SumXY - XY[FPtr];
      X[FPtr] = Bars-eFrame;
      XX[FPtr] = X[FPtr]*X[FPtr];
      Y[FPtr] = 0.5*(High[eFrame]+Low[eFrame]);
      YY[FPtr] = Y[FPtr]*Y[FPtr];
      XY[FPtr] = X[FPtr]*Y[FPtr];
      SumX = SumX + X[FPtr];
      SumXX = SumXX + XX[FPtr];
      SumY = SumY + Y[FPtr];
      SumYY = SumYY + YY[FPtr];
      SumXY = SumXY + XY[FPtr];
    }  // else {  //  if (FirstFrame) 
    Norma = Frame*SumXX-SumX*SumX;
    if (Norma == 0.0) {
      Print("MovingLR:  ");
      continue;
    }
    Norma = 1.0/Norma;
    A = (Frame*SumXY - SumX*SumY)*Norma;
    B = (SumXX*SumY - SumX*SumXY)*Norma;
//    rmsY = A*B*SumX-A*SumXY-B*SumY;
//    rmsY = rmsY+rmsY;
//    rmsY = rmsY+SumYY+A*A*SumXX+Frame*B*B;
//    rmsY = rmsY/(Frame-2);
//    if (rmsY < 0.0) {
//      Print("MovingLR:  ");
//      continue;
//    }
//    rmsY = MathSqrt(rmsY);
    Buf[eFrame] = A*(Bars-eFrame)+B;
  }  // for(bFrame = bSample; bFrame < eSample; bFrame++)
  bFrame++;
  ObjectSet(OName,OBJPROP_TIME1,Time[bFrame]);
  ObjectSet(OName,OBJPROP_PRICE1,A*(Bars-bFrame)+B);
  ObjectSet(OName,OBJPROP_TIME2,Time[eFrame]);
  ObjectSet(OName,OBJPROP_PRICE2,A*(Bars-eFrame)+B);
  
  return(0);
}